﻿Module ModuleScope

    Public Class Channel
        Public Slot As Int32
        Public neg As Boolean
        Public Max As Single
        Public Min As Single
        Public ValueMax As Single
        Public ValueMin As Single
        Public Value_Normalized As Single
        Public Value_Zero As Single
        Public Value As Single
        Public vDiv As Single
        Public RemoveDC As Boolean
        Public Enabled As Boolean
        Sub New()
            Slot = -1
            Max = 1000
            Min = 0
        End Sub
    End Class

    Friend ch1 As Channel = New Channel
    Friend ch2 As Channel = New Channel
    Friend ch3 As Channel = New Channel
    Friend ch4 As Channel = New Channel

    Friend ClearBufferEachRun As Boolean
    Friend InterpolateEnabled As Boolean
    Friend CursorsEnabled As Boolean
    Friend Cursor1 As Single = 0.33
    Friend Cursor2 As Single = 0.66
    Friend ScopeRun As Boolean
    Friend TriggerCh As Int32

    ' ------------------------------------     30'000 =                 60 sec * 500 sps (120 kilo bytes)
    ' ------------------------------------  1'800'000 =  1 h * 60 min * 60 sec * 500 sps (  4 mega bytes)
    ' ------------------------------------  3'600'000 =  2 h * 60 min * 60 sec * 500 sps (  8 mega bytes)
    ' ------------------------------------ 10'800'000 =  6 h * 60 min * 60 sec * 500 sps ( 44 mega bytes)
    ' ------------------------------------ 21'600'000 = 12 h * 60 min * 60 sec * 500 sps ( 86 mega bytes)
    ' ------------------------------------ 43'200'000 = 24 h * 60 min * 60 sec * 500 sps (172 mega bytes)

    Friend Const FifoLen As Int32 = 1800000    ' <-- 1800000 (1 h) (120 k bytes ram) (98 mega bytes disk)
    Friend fifo1 As FIFO = New FIFO(FifoLen)

    Friend BufferLenMS As Int32

    Private m_pbox As PictureBox

    Private m_SampleFreq As Int32 = 500
    Private m_SampleMillisec As Int32 = 2

    Private m_msDiv As Single = 100
    Private m_DeltaTime As Single
    Private m_LeftFifoIndex As Int32

    Private hpix As Int32
    Private wpix As Int32

    Private vpp As Single

    Private g As Graphics

    Private BackColor As Color = Color.FromArgb(250, 242, 242)
    Private textFont As Font = New Font("Arial", 9, FontStyle.Bold)
    Private timeMarkerFont As Font = New Font("Arial", 10, FontStyle.Bold)

    Private PenScale1 As Pen = New Pen(Color.FromArgb(140, 140, 140))
    Private PenScale2 As Pen = New Pen(Color.FromArgb(160, 160, 160))
    Private PenTrace1 As Pen = New Pen(Color.FromArgb(0, 40, 100), 2)
    Private PenTrace2 As Pen = New Pen(Color.DarkRed, 2)
    Private PenTrace3 As Pen = New Pen(Color.DarkGreen, 2)
    Private PenTrace4 As Pen = New Pen(Color.Black, 2)
    Private PenCursor As Pen = New Pen(Color.FromArgb(0, 120, 0), 3)
    Private BrushCursor As Brush = New SolidBrush(Color.FromArgb(0, 60, 0))
    Private BrushText As Brush = New SolidBrush(Color.FromArgb(30, 0, 0))
    Private BrushText1 As Brush = New SolidBrush(Color.DarkBlue)
    Private BrushText2 As Brush = New SolidBrush(Color.DarkRed)
    Private BrushText3 As Brush = New SolidBrush(Color.DarkGreen)
    Private BrushText4 As Brush = New SolidBrush(Color.Black)
    Private BrushBack As Brush = New SolidBrush(Color.FromArgb(150, 250, 250, 180))
    Private BrushHiLight As Brush = New SolidBrush(Color.FromArgb(180, 250, 250, 0))
    Private BrushWarning As Brush = New SolidBrush(Color.FromArgb(180, 255, 210, 0))
    Private BrushBack2 As Brush = New SolidBrush(Color.FromArgb(250, 250, 180))
    Private PenCircles As Pen = New Pen(Color.Black, 2)
    Private PenTriggerLine As Pen = New Pen(Color.Gold, 3)
    Private BrushCircles As Brush = New SolidBrush(Color.Red)
    Private BrushStartMarker As Brush = New SolidBrush(Color.FromArgb(180, 220, 180))
    Private BrushEndMarker As Brush = New SolidBrush(Color.FromArgb(200, 180, 100))

    Friend Sub InitGraphics(ByVal pbox As PictureBox, Optional ByVal HiQuality As Boolean = True)
        m_pbox = pbox
        InitPictureboxImage(m_pbox)
        If m_pbox.Image Is Nothing Then Return
        g = Graphics.FromImage(m_pbox.Image)
        If g Is Nothing Then Return
        If HiQuality Then
            g.SmoothingMode = Drawing2D.SmoothingMode.HighQuality
            PenTrace1.Width = 2
            PenTrace2.Width = 2
            PenTrace3.Width = 2
            PenTrace4.Width = 2
        Else
            g.SmoothingMode = Drawing2D.SmoothingMode.HighSpeed
            PenTrace1.Width = 1
            PenTrace2.Width = 1
            PenTrace3.Width = 1
            PenTrace4.Width = 1
        End If
        hpix = m_pbox.Image.Height - 1
        wpix = m_pbox.Image.Width - 2
        PenCursor.DashStyle = Drawing2D.DashStyle.Dot
    End Sub

    Friend Sub SetBaseTime(ByVal basetime As String)
        m_msDiv = CSng(Val(basetime))
        If basetime.Contains("mS") Then
            '
        ElseIf basetime.Contains("Sec") Then
            m_msDiv *= 1000
        ElseIf basetime.Contains("Min") Then
            m_msDiv *= 60000
        End If
        LimitDeltaTime()
    End Sub

    Friend Function GetBaseTime() As Single
        Return m_msDiv
    End Function

    Friend Sub UpdateDeltaTimeBy(ByVal DeltaPixels As Int32)
        m_DeltaTime += DeltaPixels * m_msDiv / wpix * 20
        LimitDeltaTime()
    End Sub

    Friend Sub SetDeltaTime(ByVal newDeltaTime As Single)
        m_DeltaTime = newDeltaTime
        LimitDeltaTime()
    End Sub

    Friend Sub ResetDeltaTime()
        m_DeltaTime = 0
    End Sub

    Friend Function GetDeltaTime() As Single
        Return m_DeltaTime
    End Function

    Friend Sub LimitDeltaTime()
        Dim MaxDelta As Single = BufferLenMS - ModuleScope.GetBaseTime * 20
        If m_DeltaTime > MaxDelta Then
            m_DeltaTime = MaxDelta
        End If
        If m_DeltaTime < 0 Then m_DeltaTime = 0
    End Sub

    Friend Function GetCursor1_FifoIndex() As Int32
        Return CInt(m_LeftFifoIndex + (Cursor1 * m_msDiv * 20) / m_SampleMillisec)
    End Function

    Friend Function GetCursor2_FifoIndex() As Int32
        Return CInt(m_LeftFifoIndex + (Cursor2 * m_msDiv * 20) / m_SampleMillisec)
    End Function

    ' ================================================================================
    '  Aquisition with the AccurateTimer
    ' ================================================================================
    Private WithEvents m_Timer As AccurateTimer = New AccurateTimer

    Private Sub m_Timer_TimerTick(ByVal TotalMillisec As Double) Handles m_Timer.Tick
        Static z1, z2, z3, z4 As Single
        Static oldv1, oldv2, oldv3, oldv4 As Single
        Dim v1 As Single = Slots.ReadSlot_NoNan(ch1.Slot)
        Dim v2 As Single = Slots.ReadSlot_NoNan(ch2.Slot)
        Dim v3 As Single = Slots.ReadSlot_NoNan(ch3.Slot)
        Dim v4 As Single = Slots.ReadSlot_NoNan(ch4.Slot)
        ' -------------------------------------------------- DC remover
        If ch1.RemoveDC Then
            v1 -= z1
            z1 += v1 / 100.0F
        End If
        If ch2.RemoveDC Then
            v2 -= z2
            z2 += v2 / 100.0F
        End If
        If ch3.RemoveDC Then
            v3 -= z3
            z3 += v3 / 100.0F
        End If
        If ch4.RemoveDC Then
            v4 -= z4
            z4 += v4 / 100.0F
        End If
        ' ---------------------------------------------------------------- Stop tester
        fifo1.AddElement(New FIFO.FifoEntry(v1, v2, v3, v4))
        Select Case StopMethod
            ' ------------------------------------------------------------ channel 1
            Case 1
                If TripStatus = 0 Then
                    If v1 >= StopTripPoint And oldv1 < StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v1 < StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
            Case 2
                If TripStatus = 0 Then
                    If v1 <= StopTripPoint And oldv1 > StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v1 > StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
                ' ------------------------------------------------------------ channel 2
            Case 3
                If TripStatus = 0 Then
                    If v2 >= StopTripPoint And oldv2 < StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v2 < StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
            Case 4
                If TripStatus = 0 Then
                    If v2 <= StopTripPoint And oldv2 > StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v2 > StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
                ' ------------------------------------------------------------ channel 3
            Case 5
                If TripStatus = 0 Then
                    If v3 >= StopTripPoint And oldv3 < StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v3 < StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
            Case 6
                If TripStatus = 0 Then
                    If v3 <= StopTripPoint And oldv3 > StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v3 > StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
                ' ------------------------------------------------------------ channel 4
            Case 7
                If TripStatus = 0 Then
                    If v4 >= StopTripPoint And oldv4 < StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v4 < StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
            Case 8
                If TripStatus = 0 Then
                    If v4 <= StopTripPoint And oldv4 > StopTripPoint Then
                        TripStatus = 1
                        StopEventCounter += 1
                        If StopEventCounter >= StopNumEvents Then
                            StopFlag = True
                        End If
                    End If
                Else
                    If v4 > StopTripPoint Then
                        TripStatus = 0
                    End If
                End If
        End Select
        oldv1 = v1
        oldv2 = v2
        oldv3 = v3
        oldv4 = v4
    End Sub

    Friend Sub StartStopAcquisition(ByVal run As Boolean)
        If run Then
            m_Timer.Interval = m_SampleMillisec
            m_Timer.Start()
            If ClearBufferEachRun Then
                fifo1.Flush()
            End If
            AddStartMarker()
        Else
            m_Timer.Stop()
        End If
        ' ------------------------------------- reset stop vars
        StopEventCounter = 0
        StopFlag = False
    End Sub

    Friend Sub AddStartMarker()
        Dim s() As Single = DateTimeToSingles(Now)
        For i As Int32 = 1 To 50
            fifo1.AddElement(New FIFO.FifoEntry(-999999, -999999, s(0), s(1)))
        Next
    End Sub


    ' ================================================================================
    '  Stop by events
    ' ================================================================================
    Friend StopMethod As Int32 = 0
    Friend StopTripPoint As Single = 0
    Friend StopNumEvents As Int32 = 0
    Friend StopFlag As Boolean
    Private StopEventCounter As Int32 = 0
    Private TripStatus As Int32 = 0

    ' ================================================================================
    '  SCOPE UPDATE
    ' ================================================================================
    Friend Sub ScopeUpdate()

        If m_pbox Is Nothing Then Return
        If m_pbox.Image Is Nothing Then Return

        Dim sw1 As Diagnostics.Stopwatch = New Diagnostics.Stopwatch : sw1.Start()
        ' ------------------------------------------------------------------ 
        Dim i, ix As Int32
        Dim x As Single
        Dim oldx1 As Int32
        Dim oldx2 As Int32
        Dim oldx3 As Int32
        Dim oldx4 As Int32
        Dim oldy1 As Single
        Dim oldy2 As Single
        Dim oldy3 As Single
        Dim oldy4 As Single
        Dim h1, h2, h3, h4 As Single
        Dim preTrigSamples As Int32
        Dim FifoReadIndex As Int32
        Dim SyncStartIndex As Int32
        Dim TriggerMillisec As Single
        Dim v, v1, v2, v3, v4 As Single
        Dim v1min, v2min, v3min, v4min As Single
        Dim v1max, v2max, v3max, v4max As Single
        Dim y, y1, y2, y3, y4 As Single
        Dim kmv1 As Single = hpix / 10.0F / ch1.vDiv
        Dim kmv2 As Single = hpix / 10.0F / ch2.vDiv
        Dim kmv3 As Single = hpix / 10.0F / ch3.vDiv
        Dim kmv4 As Single = hpix / 10.0F / ch4.vDiv
        Dim kw As Single = m_SampleFreq / 50.0F * m_msDiv / wpix
        Dim kw2 As Single = m_msDiv * 20 / wpix
        Dim cursor1x As Int32 = CInt(Cursor1 * wpix)
        Dim cursor2x As Int32 = CInt(Cursor2 * wpix)
        If cursor1x > cursor2x Then
            Dim d As Int32 = cursor1x
            cursor1x = cursor2x
            cursor2x = d
        End If
        Static TrigMin As Single
        Static TrigMax As Single
        ' ------------------------------------------------------------------ clear
        g.Clear(BackColor)
        ' ------------------------------------------------------------------ draw scale
        For i = 0 To 20
            x = wpix * i \ 20
            Select Case i
                Case 0, 10, 20
                    g.DrawLine(PenScale2, x - 1, 0, x - 1, hpix)
                    g.DrawLine(PenScale1, x, 0, x, hpix)
                    g.DrawLine(PenScale2, x + 1, 0, x + 1, hpix)
                Case Else
                    g.DrawLine(PenScale1, x, 0, x, hpix)
            End Select
        Next
        For i = 0 To 10
            y = hpix * i \ 10
            Select Case i
                Case 0, 5, 10
                    g.DrawLine(PenScale2, 0, y - 1, wpix, y - 1)
                    g.DrawLine(PenScale1, 0, y, wpix, y)
                    g.DrawLine(PenScale2, 0, y + 1, wpix, y + 1)
                Case Else
                    g.DrawLine(PenScale1, 0, y, wpix, y)
            End Select
        Next

        ' -------------------------------------------------------------- prepare the FIFO read position
        FifoReadIndex = CInt(fifo1.GetWriteIndex - 1)
        ' -------------------------------------------------------------- subtract delta time 
        FifoReadIndex -= CInt(m_DeltaTime / 2)
        ' -------------------------------------------------------------- Adaptive-trigger or no-trigger
        If TriggerCh > 0 Then
            preTrigSamples = Math.Min(3 * CInt(kw * wpix), FifoLen \ 2)
            Dim min As Single = Single.MaxValue
            Dim max As Single = Single.MinValue
            Dim TrigState As Int32 = 0
            For ix = FifoReadIndex To FifoReadIndex - preTrigSamples Step -1
                Select Case TriggerCh
                    Case 1
                        v = fifo1.GetElement(ix).Value1
                        If ch1.neg Then v = -v
                    Case 2
                        v = fifo1.GetElement(ix).Value2
                        If ch2.neg Then v = -v
                    Case 3
                        v = fifo1.GetElement(ix).Value3
                        If ch3.neg Then v = -v
                    Case 4
                        v = fifo1.GetElement(ix).Value4
                        If ch4.neg Then v = -v
                End Select
                If v > max Then max = v
                If v < min Then min = v
                Select Case TrigState
                    Case 0
                        If v < TrigMin Then
                            TrigState = 1
                        End If
                    Case 1
                        If v > TrigMax Then
                            TrigState = 2
                            FifoReadIndex = ix
                            SyncStartIndex = ix
                        End If
                    Case 2
                        If v < TrigMin Then
                            TrigState = 3
                        End If
                    Case 3
                        If v > TrigMax Then
                            TrigState = 4
                            TriggerMillisec = (SyncStartIndex - ix) * m_SampleMillisec
                        End If
                End Select
            Next
            ' -------------------------------------------------------------- TrigMax and TrigMin
            Dim margin As Single = (max - min) * 0.25F
            TrigMax = max - margin
            TrigMin = min + margin
        End If
        ' ------------------------------------------------------------------ FifoIndex for the left of the window
        m_LeftFifoIndex = FifoReadIndex - CInt(wpix * kw)
        ' ------------------------------------------------------------------ value zero (CenterValue)
        h1 = hpix / 2.0F + kmv1 * ch1.Value_Zero
        h2 = hpix / 2.0F + kmv2 * ch2.Value_Zero
        h3 = hpix / 2.0F + kmv3 * ch3.Value_Zero
        h4 = hpix / 2.0F + kmv4 * ch4.Value_Zero
        ' ------------------------------------------------------------------ unused traces
        If Not ch1.Enabled OrElse ch1.Slot < 0 Then kmv1 = 0 : h1 = -10000
        If Not ch2.Enabled OrElse ch2.Slot < 0 Then kmv2 = 0 : h2 = -10000
        If Not ch3.Enabled OrElse ch3.Slot < 0 Then kmv3 = 0 : h3 = -10000
        If Not ch4.Enabled OrElse ch4.Slot < 0 Then kmv4 = 0 : h4 = -10000
        ' ------------------------------------------------------------------ wave
        oldx1 = -1
        oldx2 = -1
        oldx3 = -1
        oldx4 = -1
        oldy1 = 0
        oldy2 = 0
        oldy3 = 0
        oldy4 = 0
        v1min = Single.MaxValue
        v2min = Single.MaxValue
        v3min = Single.MaxValue
        v4min = Single.MaxValue
        v1max = Single.MinValue
        v2max = Single.MinValue
        v3max = Single.MinValue
        v4max = Single.MinValue
        Dim fe As FIFO.FifoEntry
        Dim DeltaIndex As Int32
        Dim oldDeltaIndex As Int32 = -1
        Dim curs1v1, curs1v2, curs1v3, curs1v4 As Single
        Dim curs2v1, curs2v2, curs2v3, curs2v4 As Single
        Dim dt As DateTime

        Dim FirstMarker As Boolean = True
        Dim MarkerEnabled As Boolean = True

        Dim CursorDeltaValid As Boolean = True
        Dim CursorDistanceValid As Int32 = 0

        For ix = 0 To wpix - 1
            DeltaIndex = CInt(ix * kw)
            ' -------------------------------------------------------------- plot only if new sample or cursors and not interpolateenabled
            If DeltaIndex = oldDeltaIndex Then
                If Not CursorsEnabled AndAlso InterpolateEnabled Then
                    Continue For
                End If
            End If
            oldDeltaIndex = DeltaIndex
            ' -------------------------------------------------------------- get v1, v2, v3 , v4
            fe = fifo1.GetElement(m_LeftFifoIndex + DeltaIndex)
            v1 = fe.Value1
            v2 = fe.Value2
            v3 = fe.Value3
            v4 = fe.Value4
            ' -------------------------------------------------------------- start marker
            If v1 = -999999 AndAlso v2 = -999999 Then
                If MarkerEnabled Then
                    MarkerEnabled = False
                    ' ------------------------------------------------------ test if the buffer start is before the window left 
                    If (m_LeftFifoIndex + DeltaIndex) > 100 Then
                        FirstMarker = False
                    End If
                    ' ------------------------------------------------------ draw the end marker
                    If kw < 3 And Not FirstMarker Then
                        g.FillRectangle(BrushEndMarker, ix, 0, 16, hpix)
                    End If
                    ' ------------------------------------------------------ extract date from v3 and v4 singles
                    dt = SinglesToDateTime(v3, v4)
                End If
                oldx1 = -9999
                ' ---------------------------------------------------------- stop visualization of cursor data
                If ix = cursor1x Or ix = cursor2x Then
                    CursorDeltaValid = False
                End If
                If CursorDistanceValid = 1 Then CursorDistanceValid = -1
                ' ----------------------------------------------------------
                Continue For
            Else
                If Not MarkerEnabled Then
                    MarkerEnabled = True
                    g.FillRectangle(BrushStartMarker, ix - 16, 0, 16, hpix)
                    PrintTimeMarker(dt, ix)
                    '
                    If CursorsEnabled Then
                        g.DrawLine(PenCursor, cursor1x, 0, cursor1x, hpix)
                        g.DrawLine(PenCursor, cursor2x, 0, cursor2x, hpix)
                    End If
                    '
                    FirstMarker = False
                End If
            End If
            ' -------------------------------------------------------------- negative
            If ch1.neg Then v1 = -v1
            If ch2.neg Then v2 = -v2
            If ch3.neg Then v3 = -v3
            If ch4.neg Then v4 = -v4
            ' -------------------------------------------------------------- 
            y1 = h1 - kmv1 * v1
            y2 = h2 - kmv2 * v2
            y3 = h3 - kmv3 * v3
            y4 = h4 - kmv4 * v4
            ' -------------------------------------------------------------- update max and min
            If v1 > v1max Then v1max = v1
            If v1 < v1min Then v1min = v1
            If v2 > v2max Then v2max = v2
            If v2 < v2min Then v2min = v2
            If v3 > v3max Then v3max = v3
            If v3 < v3min Then v3min = v3
            If v4 > v4max Then v4max = v4
            If v4 < v4min Then v4min = v4
            ' -------------------------------------------------------------- 
            If Math.Abs(y1) > 100000 Then y1 = 0
            If Math.Abs(y2) > 100000 Then y2 = 0
            If Math.Abs(y3) > 100000 Then y3 = 0
            If Math.Abs(y4) > 100000 Then y4 = 0
            ' -------------------------------------------------------------- 
            If Double.IsNaN(y1) Then y1 = 0
            If Double.IsNaN(y2) Then y2 = 0
            If Double.IsNaN(y3) Then y3 = 0
            If Double.IsNaN(y4) Then y4 = 0
            ' -------------------------------------------------------------- if cursors or not interpolate then plot every sample
            If CursorsEnabled OrElse Not InterpolateEnabled Then
                If oldx1 >= 0 Then
                    g.DrawLine(PenTrace1, oldx1, oldy1, ix, y1)
                    g.DrawLine(PenTrace2, oldx2, oldy2, ix, y2)
                    g.DrawLine(PenTrace3, oldx3, oldy3, ix, y3)
                    g.DrawLine(PenTrace4, oldx4, oldy4, ix, y4)
                End If
                oldy1 = y1
                oldy2 = y2
                oldy3 = y3
                oldy4 = y4
                oldx1 = ix
                oldx2 = ix
                oldx3 = ix
                oldx4 = ix
            Else
                ' ---------------------------------------------------------- else plot only when y changes
                Static counter1 As Int32 = 0
                counter1 += 1
                If oldy1 <> y1 Or counter1 > 1 Then
                    counter1 = 0
                    If oldx1 >= 0 Then
                        g.DrawLine(PenTrace1, oldx1, oldy1, ix, y1)
                    End If
                    oldy1 = y1
                    oldx1 = ix
                End If
                Static counter2 As Int32 = 0
                counter2 += 1
                If oldy2 <> y2 Or counter2 > 1 Then
                    counter2 = 0
                    If oldx1 >= 0 Then
                        g.DrawLine(PenTrace2, oldx2, oldy2, ix, y2)
                    End If
                    oldy2 = y2
                    oldx2 = ix
                End If
                Static counter3 As Int32 = 0
                counter3 += 1
                If oldy3 <> y3 Or counter3 > 1 Then
                    counter3 = 0
                    If oldx3 >= 0 Then
                        g.DrawLine(PenTrace3, oldx3, oldy3, ix, y3)
                    End If
                    oldy3 = y3
                    oldx3 = ix
                End If
                Static counter4 As Int32 = 0
                counter4 += 1
                If oldy4 <> y4 Or counter4 > 1 Then
                    counter4 = 0
                    If oldx4 >= 0 Then
                        g.DrawLine(PenTrace4, oldx4, oldy4, ix, y4)
                    End If
                    oldy4 = y4
                    oldx4 = ix
                End If
            End If
            ' -------------------------------------------------------------- plot cursors
            If CursorsEnabled Then
                If ix = cursor1x Then
                    NotOverlappedPositions_Init(y1 - 6, y2 - 6, y3 - 6, y4 - 6)
                    g.DrawLine(PenCursor, ix, 0, ix, hpix)
                    g.DrawEllipse(PenTrace1, ix - 4, y1 - 4, 8, 8)
                    y = NotOverlappedPosition(1)
                    PrintXY_Left(v1.ToString(GCI), BrushText1, BrushBack2, ix - 8, y)
                    g.DrawEllipse(PenTrace2, ix - 4, y2 - 4, 8, 8)
                    y = NotOverlappedPosition(2)
                    PrintXY_Left(v2.ToString(GCI), BrushText2, BrushBack2, ix - 8, y)
                    g.DrawEllipse(PenTrace3, ix - 4, y3 - 4, 8, 8)
                    y = NotOverlappedPosition(3)
                    PrintXY_Left(v3.ToString(GCI), BrushText3, BrushBack2, ix - 8, y)
                    g.DrawEllipse(PenTrace4, ix - 4, y4 - 4, 8, 8)
                    y = NotOverlappedPosition(4)
                    PrintXY_Left(v4.ToString(GCI), BrushText4, BrushBack2, ix - 8, y)
                    curs1v1 = v1
                    curs1v2 = v2
                    curs1v3 = v3
                    curs1v4 = v4
                    If CursorDistanceValid >= 0 Then CursorDistanceValid += 1
                End If
                If ix = cursor2x Then
                    NotOverlappedPositions_Init(y1 - 6, y2 - 6, y3 - 6, y4 - 6)
                    g.DrawLine(PenCursor, ix, 0, ix, hpix)
                    g.DrawEllipse(PenTrace1, ix - 4, y1 - 4, 8, 8)
                    y = NotOverlappedPosition(1)
                    PrintXY_Left(v1.ToString(GCI), BrushText1, BrushBack2, ix - 8, y)
                    g.DrawEllipse(PenTrace2, ix - 4, y2 - 4, 8, 8)
                    y = NotOverlappedPosition(2)
                    PrintXY_Left(v2.ToString(GCI), BrushText2, BrushBack2, ix - 8, y)
                    g.DrawEllipse(PenTrace3, ix - 4, y3 - 4, 8, 8)
                    y = NotOverlappedPosition(3)
                    PrintXY_Left(v3.ToString(GCI), BrushText3, BrushBack2, ix - 8, y)
                    g.DrawEllipse(PenTrace4, ix - 4, y4 - 4, 8, 8)
                    y = NotOverlappedPosition(4)
                    PrintXY_Left(v4.ToString(GCI), BrushText4, BrushBack2, ix - 8, y)
                    curs2v1 = v1
                    curs2v2 = v2
                    curs2v3 = v3
                    curs2v4 = v4
                    If CursorDistanceValid >= 0 Then CursorDistanceValid += 1
                End If
            End If
        Next
        ' ------------------------------------------------------------------ trigger info
        If Math.Abs(oldy1) < 100000 Then g.DrawEllipse(PenCircles, oldx1 - 4, oldy1 - 4, 8, 8)
        If Math.Abs(oldy2) < 100000 Then g.DrawEllipse(PenCircles, oldx2 - 4, oldy2 - 4, 8, 8)
        If Math.Abs(oldy3) < 100000 Then g.DrawEllipse(PenCircles, oldx3 - 4, oldy3 - 4, 8, 8)
        If Math.Abs(oldy4) < 100000 Then g.DrawEllipse(PenCircles, oldx4 - 4, oldy4 - 4, 8, 8)
        If TriggerCh > 0 And TriggerMillisec > 0 Then
            Select Case TriggerCh
                Case 1
                    y = oldy1
                    x = oldx1
                Case 2
                    y = oldy2
                    x = oldx2
                Case 3
                    y = oldy3
                    x = oldx3
                Case 4
                    y = oldy4
                    x = oldx4
            End Select
            Dim x2 As Single = x - TriggerMillisec / kw / 2.0F
            If Math.Abs(y) < 100000 Then
                g.DrawEllipse(PenCircles, x2 - 4, y - 4, 8, 8)
                g.FillEllipse(BrushCircles, x - 3, y - 3, 6, 6)
                g.FillEllipse(BrushCircles, x2 - 3, y - 3, 6, 6)
                g.DrawLine(PenTriggerLine, x, y, x2, y)
            End If
            PrintXY_Left("Trigger = " + TriggerMillisec.ToString("0", GCI) + " mS  " + _
                        (1000 / TriggerMillisec).ToString("0.00", GCI) + " Hz", _
                        BrushText, BrushHiLight, wpix - 3, 3)
        End If
        ' ------------------------------------------------------------------ cursors info
        If CursorsEnabled Then
            If CursorDeltaValid Then
                PrintXY("Ch1 delta = " + Math.Abs(curs2v1 - curs1v1).ToString(GCI), BrushText1, BrushBack, 3, 3)
                PrintXY("Ch2 delta = " + Math.Abs(curs2v2 - curs1v2).ToString(GCI), BrushText2, BrushBack, 3, 20)
                PrintXY("Ch3 delta = " + Math.Abs(curs2v3 - curs1v3).ToString(GCI), BrushText3, BrushBack, 3, 37)
                PrintXY("Ch4 delta = " + Math.Abs(curs2v4 - curs1v4).ToString(GCI), BrushText4, BrushBack, 3, 54)
                If CursorDistanceValid >= 0 Then
                    Dim ms As Single = (cursor2x - cursor1x) * kw2
                    PrintXY("mS = " + ms.ToString(GCI), BrushCursor, BrushBack, 3, 74)
                    PrintXY("Hz = " + (1000 / ms).ToString(GCI), BrushCursor, BrushBack, 3, 91)
                End If
            End If
        End If
        ' ------------------------------------------------------------------ scale text - Vertical/div
        PrintBottom((ch1.vDiv).ToString(GCI) & " / div", BrushText1, BrushBack, 5)
        PrintBottom((ch2.vDiv).ToString(GCI) & " / div", BrushText2, BrushBack, 80)
        PrintBottom((ch3.vDiv).ToString(GCI) & " / div", BrushText3, BrushBack, 155)
        PrintBottom((ch4.vDiv).ToString(GCI) & " / div", BrushText4, BrushBack, 230)
        ' ------------------------------------------------------------------ scale text - TimeBase/div
        If m_msDiv >= 1000 Then
            PrintBottom((m_msDiv / 1000).ToString(GCI) & " Sec / div", BrushText, BrushBack, wpix - 80)
        Else
            PrintBottom(m_msDiv.ToString(GCI) & " mS / div", BrushText, BrushBack, wpix - 80)
        End If
        ' ------------------------------------------------------------------ scale text - TimeBase Delta
        If m_DeltaTime > 0 Then
            If m_DeltaTime >= 60000 Then
                PrintBottom("Delta time = " + (m_DeltaTime / 60000).ToString("0.000", GCI) + " min", _
                            BrushText, BrushWarning, wpix - 240)
            ElseIf m_DeltaTime >= 1000 Then
                PrintBottom("Delta time = " + (m_DeltaTime / 1000).ToString("0.000", GCI) + " Sec", _
                            BrushText, BrushWarning, wpix - 240)
            Else
                PrintBottom("Delta time = " + m_DeltaTime.ToString("0", GCI) + " mS", _
                            BrushText, BrushWarning, wpix - 230)
            End If
        End If
        ' ------------------------------------------------------------------ value Min and Max
        ch1.Value = v1
        ch2.Value = v2
        ch3.Value = v3
        ch4.Value = v4
        ch1.ValueMax = v1max
        ch1.ValueMin = v1min
        ch2.ValueMax = v2max
        ch2.ValueMin = v2min
        ch3.ValueMax = v3max
        ch3.ValueMin = v3min
        ch4.ValueMax = v4max
        ch4.ValueMin = v4min
        ' ------------------------------------------------------------------ debug info with ALT key
        'If My.Computer.Keyboard.AltKeyDown Then
        '    PrintTop("TrigMax: " & TrigMax.ToString("0.0"), BrushText, Brushes.Yellow, 200)
        '    PrintTop("TrigMin: " & TrigMin.ToString("0.0"), BrushText, Brushes.Yellow, 300)
        '    PrintTop("Scope time: " & (sw1.Elapsed.TotalMilliseconds).ToString("0.0") & " mS", _
        '             BrushText, Brushes.Yellow, 8)
        'End If
        ' ------------------------------------------------------------------ show
        m_pbox.Invalidate()
    End Sub

    Private NotOverlappedPositions(4) As Single
    Private Sub NotOverlappedPositions_Init(ByVal y1 As Single, ByVal y2 As Single, ByVal y3 As Single, ByVal y4 As Single)
        NotOverlappedPositions(1) = y1
        NotOverlappedPositions(2) = y2
        NotOverlappedPositions(3) = y3
        NotOverlappedPositions(4) = y4
        '
        NotOverlappedTest(1, 2)
        NotOverlappedTest(1, 3)
        NotOverlappedTest(1, 4)
        NotOverlappedTest(2, 3)
        NotOverlappedTest(2, 4)
        NotOverlappedTest(3, 4)
        '
        NotOverlappedTest(1, 2)
        NotOverlappedTest(1, 3)
        NotOverlappedTest(1, 4)
        NotOverlappedTest(2, 3)
        NotOverlappedTest(2, 4)
        NotOverlappedTest(3, 4)
    End Sub
    Private Sub NotOverlappedTest(ByVal i1 As Int32, ByVal i2 As Int32)
        If Math.Abs(NotOverlappedPositions(i1) - NotOverlappedPositions(i2)) < 16 Then
            If NotOverlappedPositions(i1) < NotOverlappedPositions(i2) Then
                NotOverlappedPositions(i1) = NotOverlappedPositions(i2) - 16
            Else
                NotOverlappedPositions(i2) = NotOverlappedPositions(i1) - 16
            End If
        End If
    End Sub
    Private Function NotOverlappedPosition(ByVal index As Int32) As Single
        Return NotOverlappedPositions(index)
    End Function

    Private Sub PrintXY(ByVal str As String, ByVal br1 As Brush, ByVal br2 As Brush, ByVal x As Single, ByVal y As Single)
        Dim sz As SizeF = g.MeasureString(str, textFont)
        g.FillRectangle(br2, x, y, sz.Width, sz.Height)
        g.DrawString(str, textFont, br1, x, y)
    End Sub

    Private Sub PrintXY_Left(ByVal str As String, ByVal br1 As Brush, ByVal br2 As Brush, ByVal x As Single, ByVal y As Single)
        Dim sz As SizeF = g.MeasureString(str, textFont)
        x -= sz.Width
        g.FillRectangle(br2, x, y, sz.Width, sz.Height)
        g.DrawString(str, textFont, br1, x, y)
    End Sub

    Private Sub PrintTop(ByVal str As String, ByVal br1 As Brush, ByVal br2 As Brush, ByVal x As Single)
        Dim sz As SizeF = g.MeasureString(str, textFont)
        g.FillRectangle(br2, x, 5, sz.Width, sz.Height)
        g.DrawString(str, textFont, br1, x, 5)
    End Sub

    Private Sub PrintBottom(ByVal str As String, ByVal br1 As Brush, ByVal br2 As Brush, ByVal x As Single)
        Dim sz As SizeF = g.MeasureString(str, textFont)
        g.FillRectangle(br2, x, hpix - 18, sz.Width, sz.Height)
        g.DrawString(str, textFont, br1, x, hpix - 18)
    End Sub

    Private Sub PrintTimeMarker(ByVal dt As DateTime, ByVal x As Single)
        Dim str As String = dt.ToString("yyyy-MM-dd   HH:mm:ss   + fff") + " ms"
        g.RotateTransform(-90)
        g.TextRenderingHint = Drawing.Text.TextRenderingHint.SingleBitPerPixelGridFit
        g.DrawString(str, timeMarkerFont, Brushes.Black, _
                              -(hpix \ 2 + 90), x - 15, StringFormat.GenericDefault)
        g.RotateTransform(90)
    End Sub

End Module

